package com.aitrainer.api.test

import com.aitrainer.api.model.ExerciseType
import com.aitrainer.api.repository.ExerciseTypeRepository
import org.junit.jupiter.api.Test
import org.slf4j.LoggerFactory
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.boot.test.context.SpringBootTest
import kotlin.test.assertEquals

@SpringBootTest
class ExerciseTypeTest {
    private val logger = LoggerFactory.getLogger(javaClass)

    @Autowired
    private lateinit var exerciseTypeRepository: ExerciseTypeRepository
    private var insertedId: Long = 0

    @Test
    fun testGet() {
        val id: Long = 7
        val extype: ExerciseType = exerciseTypeRepository.findById(id).orElse(null)
        assertEquals(extype.name, "4x10m-es ingafutás")
    }

    @Test
    fun testGetAll() {
        val exerciseTypes: List<ExerciseType> = exerciseTypeRepository.findAll()
        assertEquals(exerciseTypes[0].exerciseTypeId, 1)
        assertEquals(exerciseTypes[0].name, "Melső fekvőtámasz 1 perc")
    }

    @Test
    fun testInsert(){
        logger.info("Add 'Húzodzkodás 2")
        val newEx = ExerciseType( "Húzodzkodás 2", " A legtöbb húzodszkodást 24 óra alatt John Ort érte el 7600-al 2016-ban. ", null )
        val savedEx: ExerciseType = exerciseTypeRepository.save(newEx)
        assertEquals(savedEx.name, "Húzodzkodás 2")

        this.insertedId = savedEx.exerciseTypeId

        logger.info("Find 'Húzodzkodás 2")
        val extype: ExerciseType = exerciseTypeRepository.findById( savedEx.exerciseTypeId ).orElse(null)
        assertEquals( extype.name, "Húzodzkodás 2")

        logger.info("Delete 'Húzodzkodás 2")
        exerciseTypeRepository.delete(extype)
    }
}